'Soll die LinkedList Thread-Save Kompiliert werden (wenn mehrere Threads auf die selbe Linked List zugreifen knnten)
'dann sollte die folgende Definition hinzugefgt werden
#define LL_DEF_ThreadSafe												'Compiler-Direktive fr THREAD-Safe-LinkedList angeben



#include once "linkedlist.bi"											'Die Funktionen zur Linkedlist verwaltugn includieren



Dim List as LinkedList													'Eine neue Variable erstellen, welche die LinkedList speichert
Dim TItem1 as LinkedList												'Itemvariable
Dim TItem2 as LinkedList												'Itemvariable



Print
Print
Print "Add"
For X as UInteger = 1 to 5												'5 Eintrge hinzufgen
	TItem1 = List.Add("Test_" & Str(X))									'Einen neuen Eintrag hinzufgen
	Print " "; List.Count												'Anzahl Eintrge ausgeben
	For Y as UInteger = 1 to 3											'3 Eintrge zum eintrag X hinzufgen
		TItem2 = TItem1.Add("Test_" & Str(X) & "_" & Str(Y))			'Einen neuen Eintrag hinzufgen
		Print "  "; TItem1.Count										'Anzahl Eintrge ausgeben
	Next
Next



Print
Print
Print "Print"
For X as UInteger = 1 to List.Count										'Alle Eintrge durchgehen
	TItem1 = List.Item(X)												'Eintrag mit Indexnummer X ausgeben
	Print " "; TItem1.Text												'Text ausgeben
	For Y as UInteger = 1 to TItem1.Count								'Alle Eintrge durchgehen
		Print "  "; TItem1.Item(Y).Text
	Next
Next



Print
Print
Print "Index"
For X as UInteger = 1 to List.Count										'Alle Eintrge durchgehen
	TItem1 = List.Item(X)												'Eintrag mit Indexnummer X ausgeben
	Print " "; TItem1.Text; "  "; TItem1.Index; "  "; TItem1.Datatype; "  "; LL_DatatypeName(TItem1.Datatype)	'Text, Index und Datentyp ausgeben
	For Y as UInteger = 1 to TItem1.Count								'Alle Eintrge durchgehen
		Print "  "; TItem1.Item(Y).Text; "  "; TItem1.Item(Y).Index; "  "; TItem1.Item(Y).Datatype; "  "; LL_DatatypeName(TItem1.Item(Y).Datatype)
	Next
Next



Print
Print
Print "Del"
For X as UInteger = 1 to List.Count										'Alle Eintrge durchgehen
	TItem1 = List.Item(X)												'Eintrag mit Indexnummer X ausgeben
	Print " "; TItem1.Count												'Anzahl eintrge ausgeben
	TItem1.Del(1)														'Erstes Element lschen
	Print " "; TItem1.Count												'Anzahl eintrge ausgeben
Next



Print
Print
Print "Valid"
For X as UInteger = 1 to List.Count										'Alle Eintrge durchgehen
	If List.Item(X).LLPtr <> 0 Then										'Prfen ob Eintrag vorhanden ist
		Print "valid!"
	Else: Print "INVALID!"
	End If
Next



Print
Print
Print "Clear"
For X as UInteger = 1 to List.Count										'Alle Eintrge durchgehen
	TItem1 = List.Item(X)												'Eintrag mit Indexnummer X ausgeben
	Print " "; TItem1.Count												'Anzahl eintrge ausgeben
	TItem1.Clear														'ALLE Element lschen
	Print " "; TItem1.Count												'Anzahl eintrge ausgeben
Next



Print
Print
Print "Destroy"
LL_Destroy(List)														'Die LinkedList zerstren
																		'DAS IST ZWINGEND EERFODERLICH!, da sonst Speicher-leaks auftreten!

If List.LLPtr <> 0 Then
	Print "LISTE EXISTIERT NOCH!"
Else: Print "Liste erfolgreich zerstrt!"
End If

'Nach dem zerstren ist die LinkedList leer! Wird anschliessend wieder ein Eintrag hinzugefgt (ADD), wird sie automatisch erstellt und MUSS!!!!!!!
'erneut "Destroy"'t werden!!!

