'Soll die LinkedList Thread-Save Kompiliert werden (wenn mehrere Threads auf die selbe Linked List zugreifen knnten)
'dann sollte die folgende Definition hinzugefgt werden
#define LL_DEF_ThreadSafe												'Compiler-Direktive fr THREAD-Safe-LinkedList angeben



#include once "linkedlist.bi"											'Die Funktionen zur Linkedlist verwaltugn includieren



Dim List as LinkedList													'Eine neue Variable erstellen, welche die LinkedList speichert
Dim TItem1 as LinkedList												'Itemvariable



Type MyUDT																'Ein UDT erzeugen
	V_Var1 as UInteger
	V_Var2 as String
End Type



Print "Add"
Dim TPtr as MyUDT Ptr
For X as UInteger = 1 to 5												'5 Eintrge hinzufgen
	TPtr = CAllocate(SizeOf(MyUDT))										'Ein neues UDT erstellen
	With *TPtr															'Daten im UDT bearbeiten
		.V_Var1 = X
		.V_Var2 = "Test_" & Str(X)
	End With
	TItem1 = List.Add(Cast(Any Ptr, TPtr))							'Einen neuen UDT Eintrag hinzufgen
																		'Da die "Add" Funktion vielseitig gestalltet ist
																		'muss hier ein Cast() erfolgen um das UDT an den Any anzupassen.
	Print " "; List.Count												'Anzahl Eintrge ausgeben
Next



Print
Print
Print "Print"
For X as UInteger = 1 to List.Count										'Alle Eintrge durchgehen
	With *Cast(MyUDT Ptr, List.Item(X).AnyData)							'Eintrag mit Indexnummer X hohlen
																		'Wie schon beim Add muss hier auch ein Cast() erfolgen,
																		'um den Any Pointer wieder zu unserem MyUDT Pointer zu machen
		Print " U:"; .V_Var1											'UInteger des UDT's ausgeben
		Print " S:"; .V_Var2											'String des UDT's ausgeben
	End With
Next



'Beim "LL_Destroy" Werden automatisch alle AnyPtr's DeAllocated. Sprich, Alle von hand erzeugenten Pointer (Allocate)
'werden automatisch DeAllocate'ed
Print
Print
Print "Destroy"
LL_Destroy(List)														'Die LinkedList zerstren
																		'DAS IST ZWINGEND EERFODERLICH!, da sonst Speicher-leaks auftreten!

If List.LLPtr <> 0 Then
	Print "LISTE EXISTIERT NOCH!"
Else: Print "Liste erfolgreich zerstrt!"
End If

'Nach dem zerstren ist die LinkedList leer! Wird anschliessend wieder ein Eintrag hinzugefgt (ADD), wird sie automatisch erstellt und MUSS!!!!!!!
'erneut "Destroy"'t werden!!!

